Index: /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_climoz_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_climoz_m.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_climoz_m.F90	(revision 2471)
@@ -67,5 +67,5 @@
 
     use mod_grid_phy_lmdz, ONLY : nbp_lat
-    use regr1_step_av_m, only: regr1_step_av
+    use regr1_conserv_m, only: regr1_conserv
     use regr3_lint_m, only: regr3_lint
     use netcdf95, only: handle_err, nf95_close, nf95_get_att, nf95_gw_var, &
@@ -76,4 +76,5 @@
     use regular_lonlat_mod, only : boundslat_reg, south
     use nrtype, only: pi
+    use slopes_m, only: slopes
 
     integer, intent(in):: read_climoz ! read ozone climatology
@@ -92,6 +93,6 @@
     ! (of input data, converted to rad, sorted in strictly ascending order)
 
-    real, allocatable:: lat_in_edg(:)
-    ! (edges of latitude intervals for input data, in rad, in strictly
+    real, allocatable:: sin_lat_in_edg(:)
+    ! (sine of edges of latitude intervals for input data, in rad, in strictly
     ! ascending order)
 
@@ -115,14 +116,14 @@
 
     real, allocatable:: o3_regr_lat(:, :, :, :)
-    ! (jjm + 1, n_plev, 0:13, read_climoz)
+    ! (nbp_lat, n_plev, 0:13, read_climoz)
     ! mean of "o3_in" over a latitude interval of LMDZ
     ! First dimension is latitude interval.
     ! The latitude interval for "o3_regr_lat(j,:, :, :)" contains "rlatu(j)".
-    ! If "j" is between 2 and "jjm" then the interval is:
+    ! If "j" is between 2 and "nbp_lat - 1" then the interval is:
     ! [rlatv(j), rlatv(j-1)]
-    ! If "j" is 1 or "jjm + 1" then the interval is:
+    ! If "j" is 1 or "nbp_lat" then the interval is:
     ! [rlatv(1), pi / 2]
     ! or:
-    ! [- pi / 2, rlatv(jjm)]
+    ! [- pi / 2, rlatv(nbp_lat - 1)]
     ! respectively.
     ! "o3_regr_lat(:, k, :, :)" is for pressure level "plev(k)".
@@ -132,5 +133,5 @@
 
     real, allocatable:: o3_out(:, :, :, :)
-    ! (jjm + 1, n_plev, 360, read_climoz)
+    ! (nbp_lat, n_plev, 360, read_climoz)
     ! regridded ozone climatology
     ! "o3_out(j, k, l, :)" is at latitude "rlatu(j)", pressure
@@ -175,5 +176,5 @@
     latitude = latitude / 180. * pi
     n_lat = size(latitude)
-    ! We need to supply the latitudes to "regr1_step_av" in
+    ! We need to supply the latitudes to "regr1_conserv" in
     ! ascending order, so invert order if necessary:
     desc_lat = latitude(1) > latitude(n_lat)
@@ -181,8 +182,9 @@
 
     ! Compute edges of latitude intervals:
-    allocate(lat_in_edg(n_lat + 1))
-    lat_in_edg(1) = - pi / 2
-    forall (j = 2:n_lat) lat_in_edg(j) = (latitude(j - 1) + latitude(j)) / 2
-    lat_in_edg(n_lat + 1) = pi / 2
+    allocate(sin_lat_in_edg(n_lat + 1))
+    sin_lat_in_edg(1) = - 1.
+    forall (j = 2:n_lat) sin_lat_in_edg(j) = sin((latitude(j - 1) &
+         + latitude(j)) / 2.)
+    sin_lat_in_edg(n_lat + 1) = 1.
     deallocate(latitude) ! pointer
 
@@ -292,6 +294,8 @@
        print *, &
             "Found 12 months in ozone climatologies, assuming periodicity..."
-       o3_regr_lat(nbp_lat:1:-1, :, 1:12, :) = regr1_step_av(o3_in, &
-            xs=sin(lat_in_edg), xt=sin((/- pi / 2, boundslat_reg(nbp_lat-1:1:-1,south), pi / 2/)))
+       call regr1_conserv(o3_in, xs = sin_lat_in_edg, &
+            xt = (/- 1., sin(boundslat_reg(nbp_lat - 1:1:- 1, south)), 1./), &
+            vt = o3_regr_lat(nbp_lat:1:- 1, :, 1:12, :), &
+            slope = slopes(o3_in, sin_lat_in_edg))
        ! (invert order of indices in "o3_regr_lat" because "rlatu" is
        ! in descending order)
@@ -303,6 +307,8 @@
     else
        print *, "Using 14 months in ozone climatologies..."
-       o3_regr_lat(nbp_lat:1:-1, :, :, :) = regr1_step_av(o3_in, &
-            xs=sin(lat_in_edg), xt=sin((/- pi / 2, boundslat_reg(nbp_lat-1:1:-1,south), pi / 2/)))
+       call regr1_conserv(o3_in, xs = sin_lat_in_edg, &
+            xt = (/- 1., sin(boundslat_reg(nbp_lat - 1:1:- 1, south)), 1./), &
+            vt = o3_regr_lat(nbp_lat:1:- 1, :, :, :), &
+            slope = slopes(o3_in, sin_lat_in_edg))
        ! (invert order of indices in "o3_regr_lat" because "rlatu" is
        ! in descending order)
Index: /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90	(revision 2471)
@@ -41,5 +41,5 @@
 
     use mod_grid_phy_lmdz, ONLY : nbp_lat
-    use regr1_step_av_m, only: regr1_step_av
+    use regr1_conserv_m, only: regr1_conserv
     use regr3_lint_m, only: regr3_lint
     use netcdf95, only: nf95_open, nf95_close, nf95_inq_varid, handle_err, &
@@ -162,5 +162,5 @@
     latitude = latitude / 180. * pi
     n_lat = size(latitude)
-    ! We need to supply the latitudes to "regr1_step_av" in
+    ! We need to supply the latitudes to "regr1_conserv" in
     ! ascending order, so invert order if necessary:
     desc_lat = latitude(1) > latitude(n_lat)
@@ -209,6 +209,7 @@
        ! We average with respect to sine of latitude, which is
        ! equivalent to weighting by cosine of latitude:
-       v_regr_lat(nbp_lat:1:-1, :, 1:12) = regr1_step_av(o3_par_in, &
-            xs=sin(lat_in_edg), xt=sin((/- pi / 2, boundslat_reg(nbp_lat-1:1:-1,south), pi / 2/)))
+       call regr1_conserv(o3_par_in, xs = sin(lat_in_edg), &
+            xt = (/-1., sin((/boundslat_reg(nbp_lat-1:1:-1,south)/)), 1./), &
+            vt = v_regr_lat(nbp_lat:1:-1, :, 1:12))
        ! (invert order of indices in "v_regr_lat" because "rlatu" is
        ! in descending order)
Index: /LMDZ5/branches/testing/libf/phylmd/regr_pr_av_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_pr_av_m.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_pr_av_m.F90	(revision 2471)
@@ -26,5 +26,5 @@
 
     ! The target vertical LMDZ grid is the grid of layer boundaries.
-    ! Regridding in pressure is done by averaging a step function of pressure.
+    ! Regridding in pressure is conservative, second order.
 
     ! All the fields are regridded as a single multi-dimensional array
@@ -38,5 +38,6 @@
     use assert_m, only: assert
     use assert_eq_m, only: assert_eq
-    use regr1_step_av_m, only: regr1_step_av
+    use regr1_conserv_m, only: regr1_conserv
+    use slopes_m, only: slopes
     use mod_phys_lmdz_mpi_data, only: is_mpi_root
     use mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, nbp_lev
@@ -83,5 +84,6 @@
     !--------------------------------------------
 
-    call assert(size(v3, 1) == klon, size(v3, 2) == nbp_lev, "regr_pr_av v3 klon")
+    call assert(size(v3, 1) == klon, size(v3, 2) == nbp_lev, &
+         "regr_pr_av v3 klon")
     n_var = assert_eq(size(name), size(v3, 3), "regr_pr_av v3 n_var")
     call assert(shape(paprs) == (/klon, nbp_lev+1/), "regr_pr_av paprs")
@@ -112,6 +114,7 @@
     ! Regrid in pressure at each horizontal position:
     do i = 1, klon
-       v3(i, nbp_lev:1:-1, :) = regr1_step_av(v2(i, :, :), press_in_edg, &
-            paprs(i, nbp_lev+1:1:-1))
+       call regr1_conserv(v2(i, :, :), press_in_edg, &
+            paprs(i, nbp_lev + 1:1:-1), v3(i, nbp_lev:1:-1, :), &
+            slopes(v2(i, :, :), press_in_edg))
        ! (invert order of indices because "paprs" is in descending order)
     end do
Index: /LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90	(revision 2471)
@@ -28,5 +28,5 @@
     use netcdf, only:  nf90_nowrite, nf90_get_var
     use assert_m, only: assert
-    use regr1_step_av_m, only: regr1_step_av
+    use regr1_conserv_m, only: regr1_conserv
     use press_coefoz_m, only: press_in_edg
     use time_phylmdz_mod, only: day_ref
@@ -75,6 +75,6 @@
     ! Poles:
     do j = 1, nbp_lat, nbp_lat-1
-       o3_mob_regr(1, j, nbp_lev:1:-1) &
-            = regr1_step_av(r_mob(j, :), press_in_edg, p3d(1, j, nbp_lev+1:1:-1))
+       call regr1_conserv(r_mob(j, :), press_in_edg, &
+            p3d(1, j, nbp_lev + 1:1:-1), o3_mob_regr(1, j, nbp_lev:1:-1))
        ! (invert order of indices because "p3d" is in descending order)
     end do
@@ -83,8 +83,7 @@
     do j = 2, nbp_lat-1
        do i = 1, nbp_lon
-          o3_mob_regr(i, j, nbp_lev:1:-1) &
-               = regr1_step_av(r_mob(j, :), press_in_edg, &
-               p3d(i, j, nbp_lev+1:1:-1))
-             ! (invert order of indices because "p3d" is in descending order)
+          call regr1_conserv(r_mob(j, :), press_in_edg, &
+               p3d(i, j, nbp_lev + 1:1:-1), o3_mob_regr(i, j, nbp_lev:1:-1))
+          ! (invert order of indices because "p3d" is in descending order)
        end do
     end do
Index: /LMDZ5/branches/testing/libf/phylmd/screenc.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/screenc.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/phylmd/screenc.F90	(revision 2471)
@@ -54,8 +54,9 @@
 !-----------------------------------------------------------------------
       include "YOMCST.h"
+      include "flux_arp.h"
 !
 ! Variables locales  
       INTEGER :: i 
-      REAL, dimension(klon) :: cdram, cdrah, cdran, zri1, gref
+      REAL, dimension(klon) :: cdram, cdrah, cdran, zri1, gref,ycdragm
 !
 !------------------------------------------------------------------------- 
@@ -78,5 +79,12 @@
                     cdram, cdrah, zri1, pref)
       DO i = 1, knon
+        IF(ok_prescr_ust) THEN
+! La aussi il faut forcer avec ust (FC + MPL 20160210)
+        ycdragm(i) = ust*ust/(1.+speed(i))/speed(i)
+        cdram=ycdragm
+        delu(i) = ust/sqrt(cdram(i))
+        ELSE
         delu(i) = ustar(i)/sqrt(cdram(i))
+        ENDIF
         delte(i)= (testar(i)* sqrt(cdram(i)))/ &
                    cdrah(i)
Index: /LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90	(revision 2471)
@@ -36,5 +36,5 @@
 
     include "clesphys.h"
-    ! for cycle_diurne
+    ! for cycle_diurne and for iflag_z0_oce==-1 (prescribed z0)
 
 ! Input variables
@@ -244,4 +244,9 @@
        z0h(i)=0.4*14e-6 / SQRT(cdragm(i) * tmp)
     ENDDO
+ELSE IF (iflag_z0_oce==-1) THEN
+    DO i = 1, knon
+       z0m(i) = z0min
+       z0h(i) = z0min
+    ENDDO
 ELSE
        CALL abort_physic(modname,'version non prevue',1)
Index: /LMDZ5/branches/testing/libf/phylmd/write_paramLMDZ_phy.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/write_paramLMDZ_phy.h	(revision 2470)
+++ /LMDZ5/branches/testing/libf/phylmd/write_paramLMDZ_phy.h	(revision 2471)
@@ -1,25 +1,2 @@
-!
-! calcul moyennes globales
-!
-       zx_tmp_fi2d=bils*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gbils)
-       zx_tmp_fi2d=evap*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gevap)
-       zx_tmp_fi2d(:)=fevap(:, is_ter)*cell_area(:)
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gevapt)
-       zx_tmp_fi2d=zxfluxlat*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,glat)
-       zx_tmp_fi2d=(topsw0-toplw0)*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gnet0)
-       zx_tmp_fi2d=(topsw-toplw)*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gnet)
-       zx_tmp_fi2d=(rain_fall+snow_fall)*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,grain)
-       zx_tmp_fi2d=zxtsol*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gtsol)
-       zx_tmp_fi2d=zt2m*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gt2m)
-       zx_tmp_fi2d=prw*cell_area
-       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gprw)
 !
 !$OMP MASTER
@@ -68,27 +45,4 @@
 !
 !=================================================================
-! moyennes globales
-!
-      CALL histwrite(nid_ctesGCM,"bils",itau_w, &
-                     gbils,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"evap",itau_w, &
-                     gevap,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"evap_land",itau_w, &
-                     gevapt,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"flat",itau_w, &
-                     glat,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"nettop0",itau_w, &
-                     gnet0,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"nettop",itau_w, &
-                     gnet,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"precip",itau_w, &
-                     grain,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"tsol",itau_w, &
-                     gtsol,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"t2m",itau_w, &
-                     gt2m,np,ndex2d)
-      CALL histwrite(nid_ctesGCM,"prw",itau_w, &
-                     gprw,np,ndex2d)
-!=================================================================
 !
       if (ok_sync) then
Index: /LMDZ5/branches/testing/libf/phylmd/yamada4.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/yamada4.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/phylmd/yamada4.F90	(revision 2471)
@@ -6,4 +6,6 @@
   USE dimphy
   USE print_control_mod, ONLY: prt_level
+  USE ioipsl_getin_p_mod, ONLY : getin_p
+
   IMPLICIT NONE
 
@@ -75,4 +77,7 @@
   DATA first, ipas/.FALSE., 0/
   !$OMP THREADPRIVATE( first,ipas)
+  REAL,SAVE :: lmixmin=1.
+  !$OMP THREADPRIVATE(lmixmin) 
+
 
   INTEGER ig, k
@@ -107,5 +112,5 @@
   fl(zzz, zl0, zq2, zn2) = max(min(l0(ig)*kap*zlev(ig, &
     k)/(kap*zlev(ig,k)+l0(ig)),0.5*sqrt(q2(ig,k))/sqrt( &
-    max(n2(ig,k),1.E-10))), 1.)
+    max(n2(ig,k),1.E-10))), lmixmin)
 
 
@@ -116,4 +121,5 @@
     ALLOCATE (l0(klon))
     firstcall = .FALSE.
+    CALL getin_p('lmixmin',lmixmin)
   END IF
 
@@ -341,5 +347,5 @@
     DO k = 2, klev - 1
       DO ig = 1, ngrid
-        l(ig, k) = max(l(ig,k), 1.)
+        l(ig, k) = max(l(ig,k), lmixmin)
         km(ig, k) = l(ig, k)*sqrt(q2(ig,k))*sm(ig, k)
         q2(ig, k) = q2(ig, k) + dt*km(ig, k)*m2(ig, k)*(1.-rif(ig,k))
